<?php

    class User{

        private string $id;
        private string $username;
        private string $passwd;
        private string $hidenPasswd;
        private string $img;
        private string $email;

        function __construct(string $id, string $pseudo, string $password, string $image, string $mail) {
            $this->id = $id;
            $this->username = $pseudo;
            $this->passwd = $password;
            $this->hidenPasswd = hidenPassWd($password);
            $this->img = $image;
            $this->email = $mail;
        }

        public function getId() : string{
            return $this->id;
        }

        public function getUsername() : string{
            return $this->username;
        }

        public function getPasswd() : string{
            return $this->passwd;
        }

        public function getImg() : string{
            return $this->img;
        }

        public function getEmail() : string{
            return $this->email;
        }

        public function setUsername(string $username){
            $this->username = $username;
        }

        public function setPasswd(string $passwd){
            $this->passwd = $passwd;
            $this->hidenPassWd = hidenPassWd($passwd);
        }

        public function setImg(string $img){
            $this->img = $img;
        }

        public function setEmail(string $email){
            $this->email = $email;
        }
    }

    
    function hidenPassWd(string $passwd){
        if(strlen($passwd) >= 16) return str_repeat('*', 16);
        return str_repeat('*', strlen($passwd)); 
    }
?>